blob: 9ee49c11b930418d9f90edbe1240cfa6a85217ca [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Ollie Lho184a4042005-11-26 21:55:36 +000017PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000018
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000019###############################################################################
20# Defaults for the toolchain.
21
22# If you want to cross-compile, just run e.g.
23# make CC=i586-pc-msdosdjgpp-gcc
24# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000025#
26# Note for anyone editing this Makefile: gnumake will happily ignore any
27# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000028STRIP ?= strip
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000029INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000030DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000031PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000032MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010033CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000034EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000035RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000036PKG_CONFIG ?= pkg-config
37BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000038
Stefan Taunerfd0d4132012-09-25 21:24:55 +000039# The following parameter changes the default programmer that will be used if there is no -p/--programmer
40# argument given when running flashrom. The predefined setting does not enable any default so that every
41# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
42# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
43# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
44# system attached to an external programmer while the default programmer is set to the internal programmer, and
45# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
46# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020047# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
48CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000049# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000051# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020052# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000053# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000054
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000055# If your compiler spits out excessive warnings, run make WARNERROR=no
56# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000057WARNERROR ?= yes
58
59ifeq ($(WARNERROR), yes)
60CFLAGS += -Werror
61endif
62
Stefan Taunere37735a2015-01-26 22:03:35 +000063ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000064PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000065override CPPFLAGS += -I$(LIBS_BASE)/include
66override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000067endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000068
Stefan Taunerbfb067b2016-01-07 18:13:07 +000069ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000070override PKG_CONFIG += --static
71override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072endif
73
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000074# Set LC_ALL=C to minimize influences of the locale.
75# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060076# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000077LC_ALL=C
78export LC_ALL
79
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000080dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000081
82# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
83# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090084debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
85 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000086
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000087###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020088# Dependency handling.
89
90DEPENDS_ON_SERIAL := \
91 CONFIG_BUSPIRATE_SPI \
92 CONFIG_PONY_SPI \
93 CONFIG_SERPROG \
94
95DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020096 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +020097 CONFIG_INTERNAL \
98 CONFIG_NICINTEL_SPI \
99 CONFIG_OGP_SPI \
100 CONFIG_PONY_SPI \
101 CONFIG_RAYER_SPI \
102
103DEPENDS_ON_LIBPCI := \
104 CONFIG_ATAHPT \
105 CONFIG_ATAPROMISE \
106 CONFIG_ATAVIA \
107 CONFIG_DRKAISER \
108 CONFIG_GFXNVIDIA \
109 CONFIG_INTERNAL \
110 CONFIG_IT8212 \
111 CONFIG_NIC3COM \
112 CONFIG_NICINTEL \
113 CONFIG_NICINTEL_EEPROM \
114 CONFIG_NICINTEL_SPI \
115 CONFIG_NICNATSEMI \
116 CONFIG_NICREALTEK \
117 CONFIG_OGP_SPI \
118 CONFIG_SATAMV \
119 CONFIG_SATASII \
120
121DEPENDS_ON_LIBUSB1 := \
122 CONFIG_CH341A_SPI \
123 CONFIG_DEDIPROG \
124 CONFIG_DEVELOPERBOX_SPI \
125 CONFIG_DIGILENT_SPI \
126 CONFIG_PICKIT2_SPI \
127 CONFIG_RAIDEN_DEBUG_SPI \
128 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200129 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200130
131DEPENDS_ON_LIBFTDI := \
132 CONFIG_FT2232_SPI \
133 CONFIG_USBBLASTER_SPI \
134
135DEPENDS_ON_LIBJAYLINK := \
136 CONFIG_JLINK_SPI \
137
Nico Huberafca7ac2021-06-27 13:35:21 +0200138define mark_unsupported
139$(foreach p,$1, \
140 $(if $(filter $($(p)),yes), \
141 $(eval UNSUPPORTED_FEATURES += $(p)=yes), \
142 $(eval override $(p) := no)))
143endef
144
Nico Huber29c68342021-06-27 14:34:16 +0200145define filter_deps
146$(strip $(foreach p,$1, \
147 $(if $(filter $($(p)),yes), \
148 $(p))))
149endef
150
Nico Hubera54f5a42021-06-27 14:27:41 +0200151define disable_all
152$(foreach p,$1, \
153 $(eval override $(p) := no))
154endef
155
156ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
157$(call disable_all,$(DEPENDS_ON_LIBUSB1))
158endif
159
160ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
161$(call disable_all,$(DEPENDS_ON_LIBPCI))
162endif
163
Nico Huber7f898972021-06-27 13:30:50 +0200164###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000165# General OS-specific settings.
166# 1. Prepare for later by gathering information about host and target OS
167# 2. Set compiler flags and parameters according to OSes
168# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000169
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000170# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000171HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100172ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000173# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
174CC = gcc
175endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100176
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000177ifneq ($(HOST_OS), SunOS)
Adam Kaufman064b1f22007-02-06 19:47:50 +0000178STRIP_ARGS = -s
179endif
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000180
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000181# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000182# IMPORTANT: The following line must be placed before TARGET_OS is ever used
183# (of course), but should come after any lines setting CC because the line
184# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900185override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null \
186 | tail -1 | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000187
188ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000189override CPPFLAGS += -I/opt/local/include -I/usr/local/include
190override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000191endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000192
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000193ifeq ($(TARGET_OS), FreeBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000194override CPPFLAGS += -I/usr/local/include
195override LDFLAGS += -L/usr/local/lib
Andriy Gapon65c1b862008-05-22 13:22:45 +0000196endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000197
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000198ifeq ($(TARGET_OS), OpenBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000199override CPPFLAGS += -I/usr/local/include
200override LDFLAGS += -L/usr/local/lib
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000201endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000202
Stefan Taunerc65b8552013-09-12 15:48:39 +0000203ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000204# Needs special `pciutils/pci.h` for older NetBSD packages
205PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
206override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000207override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000208endif
209
210ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000211override CPPFLAGS += -I/usr/local/include
212override LDFLAGS += -L/usr/local/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000213endif
214
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000215ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000216EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000217# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000218override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000219LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200220# Missing serial support.
221$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
222# Libraries not available for DOS
223$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000224endif
Ollie Lho184a4042005-11-26 21:55:36 +0000225
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000226# FIXME: Should we check for Cygwin/MSVC as well?
227ifeq ($(TARGET_OS), MinGW)
228EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000229# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000230FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000231# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000232# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000233FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100234
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000235# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200236$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
237# And programmers that need raw access.
238$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000239
Nico Huberca621782021-06-27 13:53:49 +0200240else # No MinGW
241
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100242# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200243$(call mark_unsupported,CONFIG_NI845X_SPI)
244
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100245endif
246
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000247ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000248ifeq ($(MAKECMDGOALS),)
249.DEFAULT_GOAL := libflashrom.a
250$(info Setting default goal to libflashrom.a)
251endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000252FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200253$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000254# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200255$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000256# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200257$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100258# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200259$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000260endif
261
Nico Huberdc8e54a2021-06-27 14:17:34 +0200262# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
263ifeq ($(filter $(TARGET_OS),Linux Android), )
264$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
265$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000266endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000267
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000268ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200269# Android on x86 (currently) does not provide raw PCI port I/O operations.
270$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000271endif
272
Stefan Tauner037cd842013-08-25 00:10:56 +0000273###############################################################################
274# General architecture-specific settings.
275# Like above for the OS, below we verify user-supplied options depending on the target architecture.
276
Uwe Hermann44ffd582011-08-20 14:16:00 +0000277# Determine the destination processor architecture.
278# IMPORTANT: The following line must be placed before ARCH is ever used
279# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000280# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900281override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null \
282 | tail -1 | cut -f 2 -d'"'))
283override ENDIAN := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E endiantest.c 2>/dev/null \
284 | tail -1))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000285
Nico Huberc8801732017-12-01 18:19:43 +0000286# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
287ifneq ($(ARCH)-little, $(filter $(ARCH),x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200288$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000289endif
290
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000291# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000292# Right now this means the drivers below only work on x86.
293ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200294$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
295$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
296$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000297endif
298
Nico Huber8945b812021-06-27 14:24:53 +0200299# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
300# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000301# Right now those architectures are alpha hppa m68k sh s390
Rosen Penev34d07f02019-07-02 00:14:01 -0700302ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200303$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
304$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
305$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000306endif
307
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000308###############################################################################
309# Flash chip drivers and bus support infrastructure.
310
Stefan Tauner4404f732013-09-12 08:28:56 +0000311CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000312 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300313 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100314 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
315 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000316
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000317###############################################################################
318# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000319
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200320LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000321
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000322###############################################################################
323# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000324
Stefan Tauner9b32de92014-08-08 23:52:33 +0000325CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000326
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200327# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
328# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
329# be obtained using util/getrevision.sh, which is the common case during development.
330-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200331VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200332MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000333
Stefan Tauner76347082016-11-27 17:45:49 +0100334SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000335
Stefan Tauner76347082016-11-27 17:45:49 +0100336# No spaces in release names unless set explicitly
337RELEASENAME ?= $(shell echo "$(VERSION)" | sed -e 's/ /_/')
338
339# Inform user of the version string
340$(info Replacing all version templates with $(VERSION).)
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000341
Stefan Tauner96209122017-10-01 16:41:35 +0200342# If a VCS is found then try to install hooks.
343$(shell ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh)
344
Stefan Tauner037cd842013-08-25 00:10:56 +0000345###############################################################################
346# Default settings of CONFIG_* variables.
347
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000348# Always enable internal/onboard support for now.
349CONFIG_INTERNAL ?= yes
350
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000351# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000352CONFIG_SERPROG ?= yes
353
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000354# RayeR SPIPGM hardware support
355CONFIG_RAYER_SPI ?= yes
356
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000357# PonyProg2000 SPI hardware support
358CONFIG_PONY_SPI ?= yes
359
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000360# Always enable 3Com NICs for now.
361CONFIG_NIC3COM ?= yes
362
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000363# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
364CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000365
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000366# Always enable SiI SATA controllers for now.
367CONFIG_SATASII ?= yes
368
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000369# Highpoint (HPT) ATA/RAID controller support.
370# IMPORTANT: This code is not yet working!
371CONFIG_ATAHPT ?= no
372
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000373# VIA VT6421A LPC memory support
374CONFIG_ATAVIA ?= yes
375
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000376# Promise ATA controller support.
377CONFIG_ATAPROMISE ?= no
378
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000379# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000380CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000381
James Lairdc60de0e2013-03-27 13:00:23 +0000382# Always enable Altera USB-Blaster dongles for now.
383CONFIG_USBBLASTER_SPI ?= yes
384
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000385# MSTAR DDC support needs more tests/reviews/cleanups.
386CONFIG_MSTARDDC_SPI ?= no
387
Justin Chevrier66e554b2015-02-08 21:58:10 +0000388# Always enable PICkit2 SPI dongles for now.
389CONFIG_PICKIT2_SPI ?= yes
390
Miklós Márton324929c2019-08-01 19:14:10 +0200391# Always enable STLink V3
392CONFIG_STLINKV3_SPI ?= yes
393
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000394# Always enable dummy tracing for now.
395CONFIG_DUMMY ?= yes
396
397# Always enable Dr. Kaiser for now.
398CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000399
Joerg Fischer5665ef32010-05-21 21:54:07 +0000400# Always enable Realtek NICs for now.
401CONFIG_NICREALTEK ?= yes
402
Andrew Morganc29c2e72010-06-07 22:37:54 +0000403# Disable National Semiconductor NICs until support is complete and tested.
404CONFIG_NICNATSEMI ?= no
405
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000406# Always enable Intel NICs for now.
407CONFIG_NICINTEL ?= yes
408
Idwer Vollering004f4b72010-09-03 18:21:21 +0000409# Always enable SPI on Intel NICs for now.
410CONFIG_NICINTEL_SPI ?= yes
411
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000412# Always enable EEPROM on Intel NICs for now.
413CONFIG_NICINTEL_EEPROM ?= yes
414
Mark Marshall90021f22010-12-03 14:48:11 +0000415# Always enable SPI on OGP cards for now.
416CONFIG_OGP_SPI ?= yes
417
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000418# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000419CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000420
Simon Glassae616512016-01-23 23:27:58 +0000421# Always enable Dediprog SF100 for now.
422CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000423
Daniel Thompson45e91a22018-06-04 13:46:29 +0100424# Always enable Developerbox emergency recovery for now.
425CONFIG_DEVELOPERBOX_SPI ?= yes
426
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000427# Always enable Marvell SATA controllers for now.
428CONFIG_SATAMV ?= yes
429
David Hendricksf9a30552015-05-23 20:30:30 -0700430# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
431CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000432CONFIG_LINUX_SPI ?= yes
433
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000434# Always enable ITE IT8212F PATA controllers for now.
435CONFIG_IT8212 ?= yes
436
Urja Rannikko0870b022016-01-31 22:10:29 +0000437# Winchiphead CH341A
438CONFIG_CH341A_SPI ?= yes
439
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100440# Digilent Development board JTAG
441CONFIG_DIGILENT_SPI ?= yes
442
Jean THOMASe28d8e42022-10-11 17:54:30 +0200443# DirtyJTAG
444CONFIG_DIRTYJTAG_SPI ?= yes
445
Marc Schink3578ec62016-03-17 16:23:03 +0100446# Disable J-Link for now.
447CONFIG_JLINK_SPI ?= no
448
Nico Huber83d52072021-06-27 00:07:13 +0200449# National Instruments USB-845x is Windows only and needs a proprietary library.
450CONFIG_NI845X_SPI ?= no
451
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000452# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000453CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000454
Stefan Taunerf3503372016-02-26 23:51:21 +0000455# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
456ifeq ($(CONFIG_NOTHING), yes)
457 ifeq ($(CONFIG_EVERYTHING), yes)
458 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
459 endif
460 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
461 $(if $(filter yes, $($(var))),\
462 $(eval $(var)=no)))
463endif
464
Patrick Georgiced7ab62015-01-19 19:52:34 +0000465# Enable all features if CONFIG_EVERYTHING=yes is given
466ifeq ($(CONFIG_EVERYTHING), yes)
467$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
468 $(if $(filter no, $($(var))),\
469 $(eval $(var)=yes)))
470endif
471
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000472# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200473
474ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200475override CONFIG_BITBANG_SPI = yes
476else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000477CONFIG_BITBANG_SPI ?= no
478endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000479
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000480###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000481# Handle CONFIG_* variables that depend on others set (and verified) above.
482
483# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
484ifeq ($(TARGET_OS), libpayload)
485ifeq ($(CONFIG_INTERNAL), yes)
486ifeq ($(CONFIG_INTERNAL_DMI), no)
487UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
488else
489override CONFIG_INTERNAL_DMI = yes
490endif
491endif
492endif
493
494# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
495CONFIG_INTERNAL_DMI ?= yes
496
497###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000498# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000499# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000500
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200501ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
502FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
503else
504FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
505endif
506
Stefan Tauner265fcac2014-06-02 00:12:23 +0000507FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000508
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000509ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000510FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000511PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000512ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000513PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200514PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000515ifeq ($(CONFIG_INTERNAL_DMI), yes)
516FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
517endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000518else
519endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000520endif
521
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000522ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000523FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000524PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000525NEED_SERIAL += CONFIG_SERPROG
526NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000527endif
528
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000529ifeq ($(CONFIG_RAYER_SPI), yes)
530FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
531PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000532NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000533endif
534
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000535ifeq ($(CONFIG_PONY_SPI), yes)
536FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
537PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000538NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000539endif
540
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000541ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000542FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000543PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000544endif
545
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000546ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000547FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000548PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000549endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000550
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000551ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000552FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000553PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000554endif
555
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000556ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000557FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000558PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000559endif
560
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000561ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000562FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000563PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000564endif
565
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000566ifeq ($(CONFIG_ATAVIA), yes)
567FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
568PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000569endif
570
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000571ifeq ($(CONFIG_ATAPROMISE), yes)
572FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
573PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000574endif
575
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000576ifeq ($(CONFIG_IT8212), yes)
577FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
578PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000579endif
580
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000581ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000582# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000583FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000584PROGRAMMER_OBJS += ft2232_spi.o
585endif
586
587ifeq ($(CONFIG_USBBLASTER_SPI), yes)
588# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000589FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000590PROGRAMMER_OBJS += usbblaster_spi.o
591endif
592
Justin Chevrier66e554b2015-02-08 21:58:10 +0000593ifeq ($(CONFIG_PICKIT2_SPI), yes)
594FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
595PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000596endif
597
Miklós Márton324929c2019-08-01 19:14:10 +0200598ifeq ($(CONFIG_STLINKV3_SPI), yes)
599FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
600PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200601endif
602
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000603ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000604FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000605PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000606endif
607
608ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000609FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000610PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000611endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000612
Joerg Fischer5665ef32010-05-21 21:54:07 +0000613ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000614FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000615PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000616endif
617
Andrew Morganc29c2e72010-06-07 22:37:54 +0000618ifeq ($(CONFIG_NICNATSEMI), yes)
619FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
620PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000621endif
622
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000623ifeq ($(CONFIG_NICINTEL), yes)
624FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
625PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000626endif
627
Idwer Vollering004f4b72010-09-03 18:21:21 +0000628ifeq ($(CONFIG_NICINTEL_SPI), yes)
629FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
630PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000631endif
632
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000633ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
634FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
635PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000636endif
637
Mark Marshall90021f22010-12-03 14:48:11 +0000638ifeq ($(CONFIG_OGP_SPI), yes)
639FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
640PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000641endif
642
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000643ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
644FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000645PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000646NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000647endif
648
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000649ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000650FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000651PROGRAMMER_OBJS += dediprog.o
652endif
653
Daniel Thompson45e91a22018-06-04 13:46:29 +0100654ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
655FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
656PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100657endif
658
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000659ifeq ($(CONFIG_SATAMV), yes)
660FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
661PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000662endif
663
David Hendricksf9a30552015-05-23 20:30:30 -0700664ifeq ($(CONFIG_LINUX_MTD), yes)
665# This is a totally ugly hack.
666FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
667PROGRAMMER_OBJS += linux_mtd.o
668endif
669
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000670ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000671# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000672FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000673PROGRAMMER_OBJS += linux_spi.o
674endif
675
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000676ifeq ($(CONFIG_MSTARDDC_SPI), yes)
677# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000678FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000679NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000680PROGRAMMER_OBJS += mstarddc_spi.o
681endif
682
Urja Rannikko0870b022016-01-31 22:10:29 +0000683ifeq ($(CONFIG_CH341A_SPI), yes)
684FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
685PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000686endif
687
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100688ifeq ($(CONFIG_DIGILENT_SPI), yes)
689FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
690PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100691endif
692
Jean THOMASe28d8e42022-10-11 17:54:30 +0200693ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
694FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
695PROGRAMMER_OBJS += dirtyjtag_spi.o
696endif
697
Marc Schink3578ec62016-03-17 16:23:03 +0100698ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100699FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
700PROGRAMMER_OBJS += jlink_spi.o
701endif
702
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100703ifeq ($(CONFIG_NI845X_SPI), yes)
704FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
705
706ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
707# if the user did not specified the NI-845x headers/lib path
708# do a guess for both 32 and 64 bit Windows versions
709NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100710NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200711
712# hack to access env variable containing brackets...
713PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
714
715ifneq ($(PROGRAMFILES_X86DIR),)
716ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
717NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
718NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
719endif
720endif
721
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100722else
723NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
724NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
725endif
726
727FEATURE_CFLAGS += $(NI845X_INCLUDES)
728LIBS += -lni845x
729PROGRAMMER_OBJS += ni845x_spi.o
730endif
731
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000732ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200733LIB_OBJS += serial.o
734ifeq ($(TARGET_OS), Linux)
735LIB_OBJS += custom_baud_linux.o
736else
737LIB_OBJS += custom_baud.o
738endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000739endif
740
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000741ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000742ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000743LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000744endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000745endif
746
Nico Huberf55ca202021-06-27 14:36:06 +0200747NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000748ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000749CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000750# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
751# libpci may need raw memory, MSR or PCI port I/O on some platforms.
752# Individual drivers might have the same needs as well.
753NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000754FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000755FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000756
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000757PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000758ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000759# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000760PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000761else
762PCILIBS += -lpci
763endif
764endif
765
766ifneq ($(NEED_RAW_ACCESS), )
767# Raw memory, MSR or PCI port I/O access.
768FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
769PROGRAMMER_OBJS += physmap.o hwaccess.o
770
771ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200772ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000773PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200774endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000775else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000776ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200777ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000778PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200779endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000780else
781ifeq ($(TARGET_OS), Darwin)
782# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000783PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000784endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000785endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000786endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000787
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000788endif
789
Nico Huberf55ca202021-06-27 14:36:06 +0200790NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000791ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000792CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100793PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000794# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
795ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
796USB1LIBS += -lusb
797else
798ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000799override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000800USB1LIBS += -lusb-1.0
801else
Stefan Tauner45207062016-02-19 08:17:24 +0000802USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
803override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000804endif
805endif
806endif
807
Nico Huberf55ca202021-06-27 14:36:06 +0200808NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200809ifneq ($(NEED_LIBFTDI), )
810FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
811FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
812FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
813FEATURE_CFLAGS += $(FTDI_INCLUDES)
814FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
815# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
816# into a hard requirement for libusb, defeating the purpose of auto-enabling.
817endif
818
Nico Huberf55ca202021-06-27 14:36:06 +0200819NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100820ifneq ($(NEED_LIBJAYLINK), )
821CHECK_LIBJAYLINK = yes
822JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
823override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
824endif
825
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000826ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000827FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000828CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000829endif
830
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000831FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000832
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000833# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000834FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000835
Nico Huber8624e8c2012-11-05 21:46:33 +0100836FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
837FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
838
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000839LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000840OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000841
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000842all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000843ifeq ($(ARCH), x86)
844 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
845endif
846
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000847$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100848 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000849
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000850libflashrom.a: $(LIBFLASHROM_OBJS)
851 $(AR) rcs $@ $^
852 $(RANLIB) $@
853
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000854# TAROPTIONS reduces information leakage from the packager's system.
855# If other tar programs support command line arguments for setting uid/gid of
856# stored files, they can be handled here as well.
857TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000858
Paul Fox05dfbe62009-06-16 21:08:06 +0000859%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100860 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000861
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000862# Make sure to add all names of generated binaries here.
863# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000864# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000865clean:
Stefan Tauner4c723152016-01-14 22:47:55 +0000866 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000867 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000868
Ollie Lho184a4042005-11-26 21:55:36 +0000869distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000870 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000871
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000872strip: $(PROGRAM)$(EXEC_SUFFIX)
873 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000874
Stefan Tauner56787082011-08-18 02:27:19 +0000875# to define test programs we use verbatim variables, which get exported
876# to environment variables and are referenced with $$<varname> later
877
878define COMPILER_TEST
879int main(int argc, char **argv)
880{
881 (void) argc;
882 (void) argv;
883 return 0;
884}
885endef
886export COMPILER_TEST
887
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000888compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000889 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000890 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000891 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000892 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
893 echo "found." || { echo "not found."; \
894 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000895 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000896 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000897 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000898 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900899 ( echo "unknown (\"$(ARCH)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000900 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000901 @printf "Target OS is "
902 @# FreeBSD wc will output extraneous whitespace.
903 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900904 ( echo "unknown (\"$(TARGET_OS)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000905 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000906ifeq ($(TARGET_OS), libpayload)
907 @$(CC) --version 2>&1 | grep -q coreboot || \
908 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
909 echo "This might work but usually does not, please beware." )
910endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000911
Stefan Tauner56787082011-08-18 02:27:19 +0000912define LIBPCI_TEST
913/* Avoid a failing test due to libpci header symbol shadowing breakage */
914#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000915#if !defined PCIUTILS_PCI_H
Stefan Tauner56787082011-08-18 02:27:19 +0000916#include <pci/pci.h>
Stefan Taunerc65b8552013-09-12 15:48:39 +0000917#else
918#include <pciutils/pci.h>
919#endif
Stefan Tauner56787082011-08-18 02:27:19 +0000920struct pci_access *pacc;
921int main(int argc, char **argv)
922{
923 (void) argc;
924 (void) argv;
925 pacc = pci_alloc();
926 return 0;
927}
928endef
929export LIBPCI_TEST
930
Stefan Tauner56734502015-02-08 21:58:04 +0000931define PCI_GET_DEV_TEST
932/* Avoid a failing test due to libpci header symbol shadowing breakage */
933#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000934#if !defined PCIUTILS_PCI_H
Stefan Tauner56734502015-02-08 21:58:04 +0000935#include <pci/pci.h>
936#else
937#include <pciutils/pci.h>
938#endif
939struct pci_access *pacc;
940struct pci_dev *dev = {0};
941int main(int argc, char **argv)
942{
943 (void) argc;
944 (void) argv;
945 pacc = pci_alloc();
946 dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
947 return 0;
948}
949endef
950export PCI_GET_DEV_TEST
951
Stefan Taunere49edbb2016-01-31 22:10:14 +0000952define LIBUSB1_TEST
953#include <stddef.h>
954#include <libusb.h>
955int main(int argc, char **argv)
956{
957 (void)argc;
958 (void)argv;
959 libusb_init(NULL);
960 return 0;
961}
962endef
963export LIBUSB1_TEST
964
Marc Schink3578ec62016-03-17 16:23:03 +0100965define LIBJAYLINK_TEST
966#include <stddef.h>
967#include <libjaylink/libjaylink.h>
968int main(int argc, char **argv)
969{
970 struct jaylink_context *ctx;
971
972 (void)argc;
973 (void)argv;
974
975 jaylink_init(&ctx);
976 jaylink_exit(ctx);
977
978 return 0;
979}
980endef
981export LIBJAYLINK_TEST
982
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000983hwlibs: compiler
984 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000985ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000986 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000987 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000988 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000989 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
990 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000991 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000992 echo "Please install libpci headers or disable all features"; \
993 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000994 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000995 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
996 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000997 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000998 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000999 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +00001000 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001001 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1002 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001003 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001004 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
1005 echo "yes." || { echo "no."; \
1006 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001007 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
1008 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001009 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001010 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001011 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
1012 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001013 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001014 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001015 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001016endif
Stefan Taunere49edbb2016-01-31 22:10:14 +00001017ifeq ($(CHECK_LIBUSB1), yes)
1018 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
1019 @echo "$$LIBUSB1_TEST" > .test.c
1020 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1021 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1022 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001023 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001024 echo "Please install libusb-1.0 headers or disable all features"; \
1025 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001026 echo "See README for more information."; echo; \
1027 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1028 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
1029 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
1030 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
1031 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001032 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001033 echo "Please install libusb-1.0 or disable all features"; \
1034 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001035 echo "See README for more information."; echo; \
1036 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1037 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1038endif
Marc Schink3578ec62016-03-17 16:23:03 +01001039ifeq ($(CHECK_LIBJAYLINK), yes)
1040 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
1041 @echo "$$LIBJAYLINK_TEST" > .test.c
1042 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1043 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1044 echo "found." || { echo "not found."; echo; \
1045 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1046 echo "Please install libjaylink headers or disable the feature"; \
1047 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1048 echo "See README for more information."; echo; \
1049 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1050 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
1051 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
1052 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
1053 echo "yes." || { echo "no."; \
1054 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1055 echo "Please install libjaylink or disable the feature"; \
1056 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1057 echo "See README for more information."; echo; \
1058 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1059 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1060endif
Stefan Reinauer53e96252005-12-01 16:19:24 +00001061
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001062.features: features
1063
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001064# If a user does not explicitly request a non-working feature, we should
1065# silently disable it. However, if a non-working (does not compile) feature
1066# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001067# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001068featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001069ifeq ($(PROGRAMMER_OBJS),)
1070 @echo "You have to enable at least one programmer driver!"
1071 @false
1072endif
1073ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001074 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
1075 @false
1076endif
1077
Stefan Tauner56787082011-08-18 02:27:19 +00001078define FTDI_TEST
Stefan Tauner5c316f92015-02-08 21:57:52 +00001079#include <stdlib.h>
Stefan Tauner56787082011-08-18 02:27:19 +00001080#include <ftdi.h>
1081struct ftdi_context *ftdic = NULL;
1082int main(int argc, char **argv)
1083{
1084 (void) argc;
1085 (void) argv;
1086 return ftdi_init(ftdic);
1087}
1088endef
1089export FTDI_TEST
1090
Ilya A. Volynets-Evenbakh2c714ab2012-09-26 00:47:09 +00001091define FTDI_232H_TEST
1092#include <ftdi.h>
1093enum ftdi_chip_type type = TYPE_232H;
1094endef
1095export FTDI_232H_TEST
1096
Stefan Tauner56787082011-08-18 02:27:19 +00001097define UTSNAME_TEST
1098#include <sys/utsname.h>
1099struct utsname osinfo;
1100int main(int argc, char **argv)
1101{
1102 (void) argc;
1103 (void) argv;
1104 uname (&osinfo);
1105 return 0;
1106}
1107endef
1108export UTSNAME_TEST
1109
David Hendricksf9a30552015-05-23 20:30:30 -07001110define LINUX_MTD_TEST
1111#include <mtd/mtd-user.h>
1112
1113int main(int argc, char **argv)
1114{
1115 (void) argc;
1116 (void) argv;
1117 return 0;
1118}
1119endef
1120export LINUX_MTD_TEST
1121
Stefan Tauner8868db32012-03-13 00:18:19 +00001122define LINUX_SPI_TEST
1123#include <linux/types.h>
1124#include <linux/spi/spidev.h>
1125
1126int main(int argc, char **argv)
1127{
1128 (void) argc;
1129 (void) argv;
1130 return 0;
1131}
1132endef
1133export LINUX_SPI_TEST
1134
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001135define LINUX_I2C_TEST
1136#include <linux/i2c-dev.h>
1137#include <linux/i2c.h>
1138
1139int main(int argc, char **argv)
1140{
1141 (void) argc;
1142 (void) argv;
1143 return 0;
1144}
1145endef
1146export LINUX_I2C_TEST
1147
Nico Huber8624e8c2012-11-05 21:46:33 +01001148define CLOCK_GETTIME_TEST
1149#include <time.h>
1150
1151int main(int argc, char **argv)
1152{
1153 struct timespec res;
1154 clock_gettime(CLOCK_REALTIME, &res);
1155 return 0;
1156}
1157endef
1158export CLOCK_GETTIME_TEST
1159
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001160define NI845X_TEST
1161#include <ni845x.h>
1162
1163int main(int argc, char **argv)
1164{
1165 (void) argc;
1166 (void) argv;
1167 char I2C_Device[256];
1168 NiHandle Dev_Handle;
1169 uInt32 NumberFound = 0;
1170 ni845xFindDevice(I2C_Device, &Dev_Handle, &NumberFound);
1171 ni845xCloseFindDeviceHandle(Dev_Handle);
1172 return 0;
1173}
1174endef
1175export NI845X_TEST
1176
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001177features: compiler
1178 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001179ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001180 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001181 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001182 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001183 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1184 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
1185 printf "Checking for FT232H support in libftdi... " ; \
1186 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001187 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001188 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1189 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
1190 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
1191 ) || \
1192 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
1193 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +00001194endif
David Hendricksf9a30552015-05-23 20:30:30 -07001195ifeq ($(CONFIG_LINUX_MTD), yes)
1196 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1197 @echo "$$LINUX_MTD_TEST" > .featuretest.c
1198 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1199 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1200 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
1201 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
1202 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1203endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001204ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001205 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001206 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001207 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001208 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001209 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001210 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1211 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001212endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001213ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001214 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001215 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001216 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001217 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001218 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001219 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1220 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001221endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001222ifeq ($(CONFIG_NI845X_SPI), yes)
1223 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1224 @echo "$$NI845X_TEST" > .featuretest.c
1225 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1226
1227 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1228 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1229 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1230 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1231 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1232 echo "For the NI-845x 17.0 the library path is:"; \
1233 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1234 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1235 exit 1; }; } \
1236 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1237endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001238 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001239 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001240 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001241 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001242 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001243 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001244 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001245ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1246 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1247 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1248else
Nico Huber8624e8c2012-11-05 21:46:33 +01001249 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1250 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1251 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1252 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1253 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1254 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001255endif
Stefan Tauner56787082011-08-18 02:27:19 +00001256 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1257 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001258
Stefan Tauner4c723152016-01-14 22:47:55 +00001259$(PROGRAM).8.html: $(PROGRAM).8
1260 @groff -mandoc -Thtml $< >$@
1261
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001262$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001263 @# Add the man page change date and version to the man page
Stefan Taunerf0cbbb02017-10-01 00:49:05 +02001264 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001265
1266install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001267 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001268 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001269 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001270 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001271
Nico Huber454f6132012-12-10 13:34:10 +00001272libinstall: libflashrom.a libflashrom.h
1273 mkdir -p $(DESTDIR)$(PREFIX)/lib
1274 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1275 mkdir -p $(DESTDIR)$(PREFIX)/include
1276 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1277
Stefan Tauner76347082016-11-27 17:45:49 +01001278_export: $(PROGRAM).8
1279 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1280 @mkdir -p "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1281 @git archive HEAD | tar -x -C "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
Stefan Tauner2dc5d292017-10-04 02:18:33 +02001282# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1283 @echo "VERSION = $(VERSION)" > "$(EXPORTDIR)/flashrom-$(RELEASENAME)/versioninfo.inc"
1284 @echo "MAN_DATE = $(MAN_DATE)" >> "$(EXPORTDIR)/flashrom-$(RELEASENAME)/versioninfo.inc"
Stefan Taunere4136852017-10-01 15:57:25 +02001285# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1286# sed is required to filter out file names having the attribute set.
1287# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1288# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001289 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1290 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001291 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001292 xargs -0 sh -c 'for f; do \
1293 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
1294 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001295 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001296
Stefan Tauner76347082016-11-27 17:45:49 +01001297export: _export
1298 @echo "Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/"
1299
1300tarball: _export
David Hendrickse1a960e2017-10-19 14:54:44 -07001301 @tar -cj --format=ustar -f "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
Stefan Tauner60f7a222017-10-01 15:45:06 +02001302 $(TAROPTIONS) "flashrom-$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001303# Delete the exported directory again because it is most likely what's expected by the user.
1304 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
David Hendrickse1a960e2017-10-19 14:54:44 -07001305 @echo Created "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001306
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001307libpayload: clean
1308 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001309
Stefan Tauner76347082016-11-27 17:45:49 +01001310.PHONY: all install clean distclean compiler hwlibs features _export export tarball featuresavailable libpayload
Ollie Lho184a4042005-11-26 21:55:36 +00001311
Stefan Tauner23e10b82016-01-23 16:16:49 +00001312# Disable implicit suffixes and built-in rules (for performance and profit)
1313.SUFFIXES:
1314
Stefan Reinauere2f01582010-06-07 11:08:07 +00001315-include $(OBJS:.o=.d)